
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>JavaScript使用正则表达式 / 憋错料</title>

    <meta name="description" content="JavaScript使用正则表达式 2.0 简介 正则表达式是可以用来查找与给定模式匹配的文本的搜索模式.例如,在上一章中,我们在一个较长的字符串中查找子字符串Cookbook: var testValue = &quot;This is the Cookbook's test string&quot;; var subsValue = &quot;Cookbook&quot;; var iValue = testValue.indexOf(subsValue); //返回值12,即子字符串的索引 这段代码有效,因为我们要查找一个 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">JavaScript使用正则表达式</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>2.0 简介</strong></p>
<p>正则表达式是可以用来查找与给定模式匹配的文本的搜索模式。例如，在上一章中，我们在一个较长的字符串中查找子字符串Cookbook：</p>
<p>var testValue = &quot;This is the Cookbook‘s test string&quot;;</p>
<p>var subsValue = &quot;Cookbook&quot;;</p>
<p>var iValue = testValue.indexOf(subsValue); //返回&#20540;12，即子字符串的索引</p>
<p>这段代码有效，因为我们要查找一个严&#26684;的匹配。但是，如果想要一个更加通用的搜索，该怎么办呢？例如，我想要在&quot;Joe‘s Cooking Book&quot; 或 &quot;JavaScript Cookbook&quot;这样的字符串中搜索单词Cook和Book。</p>
<p>当要查找匹配一个模式的字符串，而不是一个具体的字符串的时候，我们需要使用正则表达式。我们也可以尝试用String函数来做到这点，但是，最终实际上使用正则表达式要更为简单，尽管语法和&#26684;式要略微奇怪一点，并且不一定“用户友好”。</p>
<p>最近，我在查看从一个字符串提取RGB的代码，以便将颜色转换为十六进制的&#26684;式。我试图只是使用String.split函数，并且根据逗号来分割，但是，随后我必须去除掉圆括号和不相关的空白。另一个需要考虑的问题是，如何可以确保&#20540;是十进制的&#26684;式呢？</p>
<p>我们可能找到的是：</p>
<p>rgb(100%, 0, 0)</p>
<p>rgb(255, 0, 0)</p>
<p>还有另一个问题：一些浏览器将颜色（例如，一个背景颜色）返回为一个RGB&#20540;，而不是一个十六进制&#20540;。在构建一个一致的转换程序的时候，你需要两种形式都能处理。</p>
<p>最后，一组正则表达式使得我们能够解决这些问题。起初，这些看上去好像是鸡毛蒜皮的问题，但是，最终它们变得要复杂很多。在流行的jQuery UI库的一个例子中，正则表达式用来匹配颜色&#20540;。这是一项复杂的任务，因为该颜色&#20540;可能呈现多种不同的&#26684;式，正如程序的这一部分所示：</p>
<p><a>//查找#a0b1c2</a></p>
<p>if (result = /#([a-fA-F0-9]{2})([a-fA-F0-9]{2})([a-fA-Z0-9]){2}/.exec(color)) {</p>
<p>return [parseInt(result[1], 16), parseInt(result[2], 16), parseInt(result[3], 16)];</p>
<p>}</p>
<p><a>//查找#fff</a></p>
<p>if (result = /#([a-fA-F0-9])([a-fA-F0-9])([a-fA-F0-9])/.exec(color)) {</p>
<p>return [parseInt(result[1]&#043;result[1],16), parseInt(result[2]&#043;result[2],16), parseInt(result[3]&#043;result[3],16)];</p>
<p>}</p>
<p><a>//在Safari3中查找rgba(0,</a>&nbsp;0, 0, 0) == transparent</p>
<p>if (result = /rgba\(0, 0, 0, 0\)/.exec(color)) {</p>
<p>return colors[‘transparent‘];</p>
<p>}</p>
<p><a>//否则，我们很可能处理一个命令的颜色</a></p>
<p>return colors[$.trim(color).toLowerCase()];</p>
<p>尽管这个正则表达式&#20284;乎有些复杂，它们实际上只不过是描述模式的一种方式。在JavaScript中，正则表达式通过RegExp对象来管理。</p>
<p><strong>RegExp直接量</strong></p>
<p>与我们在第一章中学习的String一样，RegExp也可以是一个直接量和一个对象。要创建一个RegExp直接量，使用如下的语法：</p>
<p>var re = /regular expression/;</p>
<p>正则表达式模式包含在开始的斜杠和结束的斜杠之间。注意，这个模式不是一个字符串，你不想使用单引号或双引号括起模式，除非引号本身也是要匹配的模式的一部分。</p>
<p>正则表达式是由字符串组成的，要么只是字符，要么是与特殊的组合，后者提供更加复杂的匹配。例如，下面是匹配包含单词Shelley和单词Powers的一个字符串的模式的正则表达式，这两个单词依次出现，之间有一个或多个空白字符隔开：</p>
<p>var re = /Shelley\s&#043;Powers/;</p>
<p>正则表达式模式包含在开始的斜杠和结束的斜杠之间。注意，这个模式不是一个字符串，你不想使用单引号或双引号括起模式，除非引号本身也是要匹配的模式的一部分。</p>
<p>正则表达式是由字符串组成的，要么只是字符，要么是与特殊字符的组合，后者提供更加复杂的匹配。例如，下面是匹配包含单词Shelley和单词Powers的一个字符串的模式的正则表达式，这两个单词一次出现，之间有一个或多个空白字符隔开：</p>
<p>var re = /Shelley\s&#043;Powers/;</p>
<p>这个示例中的特殊字符是反斜杠字符(\)，它有两个目的：要么与一个常规字符一起使用，表明该字符是一个特殊字符：要么与一个特殊字符一起使用，例如，加号(&#043;)，表明该字符应该当作直接量对待。在这个例子中，反斜杠与&quot;s&quot;一起使用，将该字母转换为一个特殊字符，表示空白字符，例如一个空&#26684;、制表符、换行或换页。\s特殊字符后面跟着一个加号，即\s&#043;，其中&#043;是一个标志，表示匹配之前的字符（在这个例子中，是一个空白字符）一次或多次。这个正则表达式将对如下形式有效：</p>
<p>Shelley Powers</p>
<p>它也会对下面的形式有效：</p>
<p>Shelley Powers</p>
<p>但它对下面的形式无效：</p>
<p>ShelleyPowers</p>
<p>Shelley和Powers之间有多少空白是无关紧要的，因为使用了\s&#043;。然而，使用加号则至少需要一个空白符。</p>
<p>假设如果要都对这三种都能匹配，正则表达式修改为如下&#26684;式：</p>
<p>var re = /Shelley\s*Powers/;</p>
<p>表2-1给出了JavaScript应用程序中最常用的特殊字符。</p>
<p>表2-1：正则表达式特殊字符</p>
<table>
<tbody>
<tr>
<td>字符</td>
<td>匹配</td>
<td>示例</td>
</tr>
<tr>
<td>^</td>
<td>匹配输入的开始</td>
<td>/^This/匹配&quot;This is...&quot;</td>
</tr>
<tr>
<td>$</td>
<td>匹配输入的结束</td>
<td>/end$/匹配&quot;This is the end&quot;</td>
</tr>
<tr>
<td>*</td>
<td>匹配0次或多次</td>
<td>/se*/匹配&quot;seeee&quot;，也匹配&quot;se&quot;</td>
</tr>
<tr>
<td>?</td>
<td>匹配0次或1次</td>
<td>/ap?/匹配&quot;apple&quot;和&quot;and&quot;</td>
</tr>
<tr>
<td>&#043;</td>
<td>匹配一次或多次</td>
<td>/ap&#043;/匹配&quot;apple&quot;，但不匹配&quot;and&quot;</td>
</tr>
<tr>
<td>{n}</td>
<td>严&#26684;匹配n次</td>
<td>/ap{2}/匹配&quot;apple&quot;，但不匹配&quot;apie&quot;</td>
</tr>
<tr>
<td>{n,}</td>
<td>匹配n次或多于n次</td>
<td>/ap{2,}/匹配&quot;apple&quot;和&quot;appple&quot;中的所有p，但是不匹配&quot;apie&quot;</td>
</tr>
<tr>
<td>{n,m}</td>
<td>匹配至少n次，至多m次</td>
<td>/ap{2,4}/匹配&quot;apppppple&quot;中的4个&quot;p&quot;</td>
</tr>
<tr>
<td>.</td>
<td>除了换行以外的任何字符</td>
<td>/a.e/匹配&quot;ape&quot;和axe&quot;</td>
</tr>
<tr>
<td>[...]</td>
<td>方括号中的任何字符</td>
<td>/a[px]e/匹配&quot;ape&quot;和&quot;axe&quot;，但不匹配&quot;ale&quot;</td>
</tr>
<tr>
<td>[^...]</td>
<td>方括号中字符以外的任何字符</td>
<td>/a[^px]/ &quot;ale&quot;，但是不匹配&quot;axe&quot;或&quot;ape&quot;</td>
</tr>
<tr>
<td>\b</td>
<td>匹配边界上的单词</td>
<td><a>/\bno/匹配</a>&nbsp;&quot;nono&quot;中的第一个&quot;no&quot;</td>
</tr>
<tr>
<td>\B</td>
<td>匹配非边界上的单词</td>
<td>/\Bno/匹配&quot;nono&quot;中的第二个&quot;no&quot;</td>
</tr>
<tr>
<td>\d</td>
<td>从0到9的数字</td>
<td><a>/\d{3}/匹配</a>&nbsp;&quot;Now in 123&quot;中的&quot;123&quot;</td>
</tr>
<tr>
<td>\D</td>
<td>任何非数字的字符</td>
<td><a>/\D{2,4}/</a>&nbsp;匹配&quot;Now in 123&quot;中的&quot;Now &quot;</td>
</tr>
<tr>
<td>\w</td>
<td>匹配单词字符（字母、数字、下划线）</td>
<td>/\w/匹配javascript中的&quot;j&quot;</td>
</tr>
<tr>
<td>\W</td>
<td>匹配任何非单词的字符（非字母、数字、下划线）</td>
<td>/\W/匹配&quot;100%&quot;中的&quot;%&quot;</td>
</tr>
<tr>
<td>\n</td>
<td>匹配一个换行</td>
<td>&nbsp;</td>
</tr>
<tr>
<td>\s</td>
<td>一个单个的空白字符</td>
<td>&nbsp;</td>
</tr>
<tr>
<td>\S</td>
<td>一个单个的非空白字符</td>
<td>&nbsp;</td>
</tr>
<tr>
<td>\t</td>
<td>一个制表符</td>
<td>&nbsp;</td>
</tr>
<tr>
<td>(x)&nbsp;</td>
<td>捕获圆括号</td>
<td>记住匹配的字符</td>
</tr>
</tbody>
</table>
<p><strong>作为对象的RegExp</strong></p>
<p>RegExp是一个JavaScript对象，也是一个直接量，因此，它也可以使用一个构造函数来创建，如下所示：</p>
<p>var re = new RegExp(&quot;Shelley\s&#043;Powers&quot;);</p>
<p>何时使用这两种形式呢？RegExp直接量在脚本运行时才编译，因此，当你知道表达式不会修改的时候，使用一个RegExp直接量。一个编译过的版本会更高效。当要修改表达式或构建表达式或提供给运行时的时候，就使用构造函数。</p>
<p>与其他的JavaScript对象一样，RegExp也有一些属性和方法，本章中将会介绍其中最常见的几个。</p>
<p><strong>2.1 测试一个子字符串是否存在</strong></p>
<p>问题：想要测试一个字符串中是否包含另一个字符串。</p>
<p><strong>解决方案</strong></p>
<p>使用一个JavaScript正则表达式来定一个搜索模式，然后，根据要搜索的字符串来应用该模式，使用RegExp test方法。在如下的代码中，我想要匹配带有Cook和Book这两个单词的任何字符串，两个单词按照前后顺序出现：</p>
<p>var cookbookstring = [</p>
<p>&quot;Joe‘s Cooking Book&quot;,</p>
<p>&quot;Sam‘s Cookbook&quot;,</p>
<p>&quot;JavaScript CookBook&quot;,</p>
<p>&quot;JavaScript BookCook&quot;</p>
<p>];</p>
<p><a>//搜索模式</a></p>
<p>var pattern = /Cook.*Book/;</p>
<p>for (var i = 0; i &lt; cookbookstring.length; i&#043;&#043;) {</p>
<p>alert(cookbookstring[i] &#043; &quot; &quot; &#043; pattern.test(cookbookstring[i]));</p>
<p>}</p>
<p>第一个字符串和第三个字符串有一个正确的匹配，而第二个字符串和第四个字符串则没有。</p>
<p><strong>讨论</strong></p>
<p>RegExp test方法接受两个参数：要测试的字符串和一个可选的修饰符。它对该字符串应用正则表达式，如果有一个匹配的话，返回true，如果没有匹配的话，返回false。</p>
<p>在这个例子中，模式是单词Cook出现在字符串的某处，并且单词Book出现在字符串中Cook之后的某处。两个单词之间可以有任意数目的字符，包括没有任何字符，正如模式中用两个正则表达式字符串所指定的那样：小数点（.）和星号（*）。</p>
<p>正则表达式中的小数点是一个特殊字符，它匹配换行符以外的任何字符。在示例的模式中，小数点后面跟着星号，它表示匹配之前的字符0次或多次。组合到一起，它们产生一个模式，匹配任何字符0次或多次，除了换行符之外。</p>
<p>在这个示例中，第一个和第三个字符串匹配，因为它们都满足了Cook和Book之间可以有任何内容的要求。第四个字符串不匹配，因为在字符串中，Book出现在了Cook的前面。第二个字符串也不匹配，由于book的第一个字母是小写的而不是大写的，并且该匹配模式是区分大小写的。</p>
<p><strong>2.2 测试不区分大小写的子字符串匹配</strong></p>
<p><strong>问题：</strong></p>
<p>你想要测试一个字符串是否包含于另一个字符串之中，但是你并不在意两个字符串中的字符的大小写。</p>
<p><strong>解决方案：</strong></p>
<p>在创建正则表达式的时候，使用忽略大小写标志(i)：</p>
<p>var cookbookString = [</p>
<p>&quot;Joe‘s Cooking Book&quot;,</p>
<p>&quot;Sam‘s Cookbook&quot;,</p>
<p>&quot;JavaScript CookBook&quot;,</p>
<p>&quot;JavaScript cookbook&quot;</p>
<p>];</p>
<p><a>//搜索模式</a></p>
<p>var pattern = /Cook.*Book/i;</p>
<p>for (var i = 0; i &lt; cookbookString.length; i&#043;&#043;) {</p>
<p>alert(cookbookString[i] &#043; &quot; &quot; &#043; pattern.test(cookbookString[i], i));</p>
<p>}</p>
<p>所有4个字符串都匹配该模式。</p>
<p><strong>讨论</strong></p>
<p>该解决方案使用了一个正则表达式标志(i)，来修改对模式匹配的限制。在这个例子中，该标志去除了模式匹配必须按照大小写匹配的限制。使用这一标志，book的&#20540;和Book的&#20540;都将是匹配的。</p>
<p>还有几个正则表达式标志，参见表2-2。它们可以与RegExp直接量一起使用：</p>
<p>var pattern = /Cook.*Book/i; // ‘i‘是忽略标志</p>
<p>也可以在创建一个RegExp对象的时候，通过可选的第二个参数来使用它们：</p>
<p>var pattern = new RegExp(&quot;Cook.*Book&quot;, &quot;i&quot;);</p>
<p>表2-2：正则表达式标志</p>
<table>
<tbody>
<tr>
<td>标志</td>
<td>含义</td>
</tr>
<tr>
<td>g</td>
<td>全局匹配：在整个字符串中匹配，而不是在第一次匹配之后停止</td>
</tr>
<tr>
<td>i</td>
<td>忽略大小写</td>
</tr>
<tr>
<td>m</td>
<td>对多行字符串中的每一行，应用行首和行末的特殊字符（分别是^和$）</td>
</tr>
</tbody>
</table>
<p><strong>2.3 验证社会安全号码</strong></p>
<p><strong>问题：</strong></p>
<p>你需要验证一个文本字符串是否是一个有效的美国社会安全号码（在美国，这是收税者用来找到我们的身份标识）。</p>
<p><strong>解决方案：</strong></p>
<p>使用String match方法和一个正则表达式来验证一个字符串是一个社会安全号码：</p>
<p>var ssn = document.getElementById(&quot;pattern&quot;).value;</p>
<p>var pattern = /^\d{3}-\d{2}-\d{4}$/;</p>
<p>if (ssn.match(pattern)) {</p>
<p>alert(&quot;OK&quot;);</p>
<p>} else {</p>
<p>alert(&quot;Not OK&quot;);</p>
<p>}</p>
<p><strong>讨论：</strong></p>
<p>美国社会安全号码是9位数字的一个组合，通常依次是3个数字、2个数字和4个数字，之间可能有连字符或者没有。</p>
<p>社会安全号码中的数字可以用数字特殊字符(\d)来匹配。要查找一组数字，可以使用花括号把期待的数字的数目括起来。在这个例子中，前3个数字可以用\d{3}来匹配。</p>
<p>第二组数字可以使用同样的规则来确定。由于数字序列之间只有一个连字符，可以不用任何特殊的字符来给定它。然而，如果字符串也可能有一个不带连字符的社会安全号码，你希望将该正则表达式模式修改为如下所示：</p>
<p>var pattern = /^\d{3}-?\d{2}-?\d{4}$/;</p>
<p>问号特殊字符(?)匹配其前面的字符0次或者仅1次，在这个例子中，这个字符就是连字符(-)。通过这一修改，如下的字符串将匹配：</p>
<p>444-55-3333</p>
<p>如下的也会匹配：</p>
<p>555335555</p>
<p>但是，下面的字符串不会匹配，它的连字符太多了：</p>
<p>555---60--4444</p>
<p>另一个特点是，检查字符串是否包含社会安全号码（并且只有社会安全号码）。输入开始特殊字符（^）用来表示社会安全号码从字符串的开始处开始，行末特殊字符($)用来表示该行以社会安全号码的末尾为结束。</p>
<p>由于只是对验证字符串是一个有效&#26684;式的社会安全号码感兴趣，我们使用了String对象的match方法。我们还可以使用RegExp test方法，但是，两种方法差不多，都可以接收。</p>
<p>还有其他的方法可以验证社会安全号码，但是较为复杂，是基于社会安全号码可以用空&#26684;代替连字符的原理。这就是为什么大多数Web站点要求按照3个不同的输入字段来提供一个社会安全号码，以避免出现各种变体。正则表达式不应该用来替代良好的表单设计。</p>
<p>此外，没有方法真正地验证给定的数字就是一个真实的社会安全号码，除非你拥有关于这个人的更多信息，并且有一个存储所有社会安全号码的数据库。使用正则表达式所能够做的，只是验证数字的&#26684;式。</p>
<p><strong>2.4 找到并突出显示一个模式的所有实例</strong></p>
<p><strong>问题：</strong></p>
<p>想要在一个字符串中找到一个模式的所有实例</p>
<p><strong>解决方案：</strong></p>
<p>在一个循环中，使用RegExp exec方法和全局标志(g)，来找到一个模式的所有示例，例如，任何以t开头并且以e结尾、中间有任意多个字符的单词或其他文本：</p>
<p>var searchString = &quot;Now is the time and this is the time and that is the time&quot;;</p>
<p>var pattern = /t\w*e/g;</p>
<p>var matchArray;</p>
<p>var str = &quot;&quot;;</p>
<p>while ((matchArray = pattern.exec(searchString)) != null) {</p>
<p>str &#043;= &quot;at &quot; &#043; matchArray.index &#043; &quot;we found&quot; &#043; matchArray[0] &#043; &quot;&lt;br /&gt;&quot;;</p>
<p>}</p>
<p>document.getElementById(&quot;results&quot;).innerHTML = str;</p>
<p><strong>讨论</strong></p>
<p>RegExp exec方法执行该正则表达式，如果没有找到一个匹配，返回null，或者，如果找到一个匹配，返回带有信息的一个数组。返回的数组中所包含的，是实际匹配的&#20540;、在字符串中找到匹配的索引、任何带圆括号的子字符串匹配，以及最初的字符串。</p>
<p>index：定位匹配的索引</p>
<p>input：最初的输入字符串</p>
<p>[0]：或直接访问数组匹配&#20540;</p>
<p>[1],...,[n]：带圆括号的子字符串匹配</p>
<p>在这个解决方案中，除了打印出匹配的&#20540;，还打印出找到匹配的位置的索引。</p>
<p>这一解决方案还使用了全局标志(g)。这触发了RegExp对象去保留每一次匹配的位置，并且从之前找到的匹配的后面开始搜索。当用于循环中的时候，我们可以找到模式匹配字符串的所有实例。在这个解决方案中，将有如下的输出：</p>
<p>at 7 we found the</p>
<p>at 11 we found time</p>
<p>at 28 we found the</p>
<p>at 32 we found time</p>
<p>at 49 we found the</p>
<p>at 53 we found time</p>
<p>time和the都匹配该模式。</p>
<p>让我们来看看应用全局搜索的本质。在示例2-1中，我们创建了一个Web页面，它带有一个textarea和一个输入文本框，分别用来获取一个搜索字符串和一个模式。模式用来创建一个RegExp对象，随后将其应用于字符串。构建了一个结果字符串。其中包含了未匹配的文本和匹配的文本，只不过匹配的文本用一个span元素包围起来，该元素一个CSS类用来突出显示该文本。然后使用div元素的innerHTML，将结果字符串插入到该页面中。</p>
<p>示例2-1：使用exec和全局标志来查找并突出显示一个文本字符串中的所有匹配</p>
<p>&lt;!doctype html&gt;</p>
<p>&lt;html xmlns=&quot;http://www.w3.org/1999/xhtml&quot;&gt;</p>
<p>&lt;head&gt;</p>
<p>&lt;title&gt;Searching for strings&lt;/title&gt;</p>
<p>&lt;style type=&quot;text/css&quot;&gt;</p>
<p>#searchSubmit {</p>
<p>background-color: #ff0;</p>
<p>width: 200px;</p>
<p>text-align: center;</p>
<p>padding: 10px;</p>
<p>border:2px inset #ccc;</p>
<p>}</p>
<p>.found {</p>
<p>background-color: #ff0;</p>
<p>}</p>
<p>&lt;/style&gt;</p>
<p>&lt;script type=&quot;text/javascript&quot;&gt;</p>
<p>//&lt;![CDATA[</p>
<p>window.onload = function() {</p>
<p>document.getElementById(&quot;searchSubmit&quot;).onclick = doSearch;</p>
<p>}</p>
<p>function doSearch() {</p>
<p><a>//获取模式</a></p>
<p>var pattern = document.getElementById(&quot;pattern&quot;).value;</p>
<p>var re = new RegExp(pattern, &quot;g&quot;);</p>
<p><a>//获取字符串</a></p>
<p>var searchString = document.getElementById(&quot;incoming&quot;).value;</p>
<p>var matchArray;</p>
<p>var resultString = &quot;&lt;pre&gt;&quot;;</p>
<p>var first = 0;</p>
<p>var last = 0;</p>
<p><a>//找到每一个匹配</a></p>
<p>while ((matchArray = re.exec(searchString)) != null) {</p>
<p>last = matchArray.index;</p>
<p><a>//获取所有匹配的字符串，将其连接起来</a></p>
<p>resultString &#043;= searchString.substring(first, last);</p>
<p><a>//使用class，添加匹配的字符串</a></p>
<p>resultString &#043;= &quot;&lt;spn class=‘found‘&gt;&quot; &#043; matchArray[0] &#043; &quot;&lt;/span&gt;&quot;;</p>
<p>first = re.lastIndex;</p>
<p>}</p>
<p><a>//完成字符串</a></p>
<p>resultString &#043;= searchString.substring(first, searchString.length);</p>
<p>resultString &#043;= &quot;&lt;/pre&gt;&quot;;</p>
<p><a>//插入到页面</a></p>
<p>document.getElementById(&quot;searchResult&quot;).innerHTML = resultString;</p>
<p>}</p>
<p>//--&gt;&lt;!]]&gt;</p>
<p>&lt;/script&gt;</p>
<p>&lt;/head&gt;</p>
<p>&lt;body&gt;</p>
<p>&lt;form id=&quot;textsearch&quot;&gt;</p>
<p>&lt;textarea id=&quot;incoming&quot; cols=&quot;150&quot; rows=&quot;10&quot;&gt;&lt;/textarea&gt;</p>
<p>&lt;p&gt;Search pattern: &lt;input id=&quot;pattern&quot; type=&quot;text&quot; /&gt;&lt;/p&gt;</p>
<p>&lt;/form&gt;</p>
<p>&lt;p id=&quot;searchSubmit&quot;&gt;Search for pattern&lt;/p&gt;</p>
<p>&lt;div id=&quot;searchResult&quot;&gt;&lt;/div&gt;</p>
<p>&lt;/body&gt;</p>
<p>&lt;/html&gt;</p>
<p>图2-1显示了这个程序在William Wordsworth的诗歌 &quot;The Kitten and the Falling Leaves&quot;上的应用，在搜索了乳腺癌的模式之后：</p>
<p>竖杠(|)是一个条件测试，并且将根据竖杠左边或右边的&#20540;来匹配一个单词。因此，想leaf这样的单词会匹配，想leave这样的单词也会匹配，而leap这样的单词不会匹配。</p>
<p>可以通过RegExp的lastIndex属性，来获取找到的最后一个索引。如果你想要把第一个匹配和最后一个匹配都记录下来，lastIndex属性很方便。</p>
<p><strong>2.5使用新字符串替换模式</strong></p>
<p><strong>问题：</strong></p>
<p>想要用一个新的子字符串替换所有匹配的子字符串。</p>
<p><strong>解决方案：</strong></p>
<p>使用String对象的replace方法和一个正则表达式：</p>
<p>var searchString = &quot;Now is the time, this is the time&quot;;</p>
<p>var re = /t\w{2}e/g;</p>
<p>var replacement = searchString.replace(re, &quot;place&quot;);</p>
<p>alert(replacement);&nbsp;<a>//字符串变成了&quot;Now</a>&nbsp;is the place, this is the place&quot;</p>
<p><strong>讨论：</strong></p>
<p>在2.4节的示例2-1中，我们使用了RegExp全局标志(g)，以记录正则表达式的每一次出现。每次匹配都使用一个span元素和CSS来突出显示。</p>
<p>对于典型的查找替换行为，全局搜索也很方便。使用全局标志(g)和一个正则表达式，并结合String replace方法，将可以使用替换字符串来替代匹配文本的所有实例。</p>
<p><strong></p>
<p></strong></p>
<p><strong>2.6 使用捕获圆括号交换一个字符串中单词</strong></p>
<p><strong>问题：</strong></p>
<p>我们可以接受一个带有名称和姓氏的输入字符串，并且交换名称，以便让姓氏先出现。</p>
<p><strong>解决方案</strong></p>
<p>使用捕获圆括号和一个正则表达式在字符串中找到并记住两个名字，然后互换它们：</p>
<p>var name = &quot;Abe Lincoln&quot;;</p>
<p>var re = /^(\w&#043;)\s(\w&#043;)$/;</p>
<p>var newname = name.replace(re, &quot;$2, $1&quot;);</p>
<p><strong>讨论</strong></p>
<p>捕获圆括号使得我们不仅能够匹配字符串中的特定模式，而且稍后可以引用匹配的子字符串。匹配的子字符串用数字来引用，从左到有，在String replace方法中使用 &quot;$1&quot;和&quot;$2&quot;来表示。</p>
<p>在这个解决方案中，正则表达式匹配两个单词，这两个单词用空&#26684;隔开。对这两个单词，都应用了捕获圆括号，因此，使用&quot;$1&quot;访问名称，使用&quot;$2&quot;访问姓氏。</p>
<p>捕获圆括号并非是可以与String replace方法一起使用的唯一的特殊字符。表2-3给出了可以与正则表达式和replace一起使用的其他特殊字符。</p>
<p><strong>表2-3：String.replace特殊模式</strong></p>
<table>
<tbody>
<tr>
<td>模式</td>
<td>用途</td>
</tr>
<tr>
<td>$$</td>
<td>允许替换中有一个直接量-美元符号($)</td>
</tr>
<tr>
<td>$&amp;</td>
<td>插入匹配的子字符串</td>
</tr>
<tr>
<td>$`</td>
<td>在匹配之前插入字符串的一部分</td>
</tr>
<tr>
<td>$’</td>
<td>在匹配之后插入字符串的一部分</td>
</tr>
<tr>
<td>$n</td>
<td>插入使用RegExp的第n次捕获圆括号的&#20540;</td>
</tr>
</tbody>
</table>
<p>该表的第二条“插入匹配的子字符串”，可以用来提供2.4节中的示例2-1的一个简化版本。该示例找到匹配的子字符串，并且提供标记和CSS来样式化它。它使用一个循环来找到并替换所有的条目，但是在示例2-2中，我们将使用String replace方法和匹配的字符串的特殊模式($&amp;)：</p>
<p>示例2-2：使用String.replace和特殊模式在字符串中查找文本并突出显示</p>
<p>&lt;!doctype html&gt;</p>
<p>&lt;html xmlns=&quot;http://www.w3.org/1999/xhtml&quot;&gt;</p>
<p>&lt;head&gt;</p>
<p>&lt;title&gt;Searching for strings&lt;/title&gt;</p>
<p>&lt;style&gt;</p>
<p>#searchSubmit {</p>
<p>background-color: #ff0;</p>
<p>width: 200px;</p>
<p>text-align: center;</p>
<p>padding: 10px;</p>
<p>border: 2px insert #ccc;</p>
<p>}</p>
<p>.found {</p>
<p>background-color: #ff0;</p>
<p>}</p>
<p>&lt;/style&gt;</p>
<p>&lt;script&gt;</p>
<p>//&lt;![CDATA[</p>
<p>window.onload = function() {</p>
<p>document.getElementById(&quot;searchSubmit&quot;).onclick = doSearch;</p>
<p>}</p>
<p>function doSearch() {</p>
<p><a>//获取模式</a></p>
<p>var pattern = document.getElementById(&quot;pattern&quot;).value;</p>
<p>var re = new RegExp(pattern, &quot;g&quot;);</p>
<p><a>//获取字符串</a></p>
<p>var searchString = document.getElementById(&quot;incoming&quot;).value;</p>
<p><a>//替换</a></p>
<p>var resultString = searchString.replace(re, &quot;&lt;span class=‘found‘&gt;$&amp;&lt;/span&gt;&quot;);</p>
<p><a>//插入到页面</a></p>
<p>document.getElementById(&quot;searchResult&quot;).innerHTML = resultString;</p>
<p>}</p>
<p>//--&gt;&lt;!]]&gt;</p>
<p>&lt;/script&gt;</p>
<p>&lt;/head&gt;</p>
<p>&lt;body&gt;</p>
<p>&lt;form id=&quot;textsearch&quot;&gt;</p>
<p>&lt;textarea id=&quot;incoming&quot; cols=&quot;100&quot; rows=&quot;10&quot;&gt;</p>
<p>&lt;/textarea&gt;</p>
<p>&lt;p&gt;</p>
<p>Search pattern: &lt;input id=&quot;pattern&quot; type=&quot;text&quot; /&gt;</p>
<p>&lt;/p&gt;</p>
<p>&lt;/form&gt;</p>
<p>&lt;p id=&quot;searchSubmit&quot;&gt;Search for pattern&lt;/p&gt;</p>
<p>&lt;div id=&quot;searchResult&quot;&gt;&lt;/div&gt;</p>
<p>&lt;/body&gt;</p>
<p>&lt;/html&gt;</p>
<p>这是一个简单的替代。如图2-2所示，这一技术不会严&#26684;保留最初的字符串的所有方面。在示例2-2中，换行没有保留，但是在示例2-1中，它们保留了。</p>
<p>当你使用RegExp exec方法的时候，还可以通过RegExp对象来访问捕获的文本。现在，让我们回到第2.6节的解决方案的代码，但这一次使用RegExp的exec方法：</p>
<p>var name = &quot;Shelley Powers&quot;;</p>
<p>var re = /^(\w&#043;)\s(\w&#043;)$/;</p>
<p>var result = re.exec(name);</p>
<p>var newname = result[2] &#043; &quot;, &quot; &#043; result[1];</p>
<p>如果想要访问捕获圆括号&#20540;，这种方法很方便，但是，在字符串替换中不一定要使用它们。要查看使用捕获圆括号的另一个示例，1.7节展示了访问如下句子的列表项的几种方法，用到了String split方法：</p>
<p>var sentence = &quot;This is one sentence. This is a sentence with a list of items: cherries, oranges, apples, bananas.&quot;;</p>
<p>另一种方法如下所示，使用捕获圆括号和RegExp exec方法：</p>
<p>var re = /:(.*)\./;</p>
<p>var result = re.exec(sentence);</p>
<p>var list = result[1]; // cherries, oranges, apples, bananas</p>
<p><strong>2.7 使用正则表达式来去除空白</strong></p>
<p><strong>问题</strong></p>
<p>在通过一个Ajax调用把一个字符串发送给服务器之前，我们想要去除字符串开始处和结尾处的空白。</p>
<p><strong>解决方案</strong></p>
<p>在新的ECMAScript 5规范之前，我们需要使用一个正则表达式来去除字符串开始处和结尾处的空白：</p>
<p>var testString = &quot; this is the string &quot;;</p>
<p>//去除开头处的空白</p>
<p>testString = testString.replace(/^\s&#043;/, &quot;&quot;);</p>
<p><a>//去除结尾处的空白testString</a>&nbsp;= testString.replace(/\s&#043;$/, &quot;&quot;);</p>
<p>从ECMAScript 5开始，String对象有了一个trim方法：</p>
<p>var testString = &quot; this is the string &quot;;</p>
<p>testString = testString.trim(); //空白去除掉了</p>
<p><strong>讨论</strong></p>
<p>从元素获取的字符串&#20540;有时候在实际的表单&#20540;的前面和后面都会有空白。通常，我们想要发送没有多余空白的字符串，因此需要使用一个正则表达式来修正字符串。</p>
<p>有了ECMAScript 5之后，现在又有了一个String trim方法。然而，ECMAScript 5还没有广泛使用，因此，我们需要检查是否存在trim方法，如果不存在的话，使用旧的正则表达式是一种安全保险的方法。</p>
<p>此外，ECMAScript 5中没有左去除和右去除，尽管在Firefox这样的一些浏览器中，有这些方法的非标准版本。因此，如果只是想要左去除或右去除，我们需要创建自己的函数：</p>
<p>function leftTrim(str) {</p>
<p>return str.replace(/^\s&#043;/, &quot;&quot;);</p>
<p>}</p>
<p>function rightTrim(str) {</p>
<p>return str.replace(/\s&#043;$/, &quot;&quot;);</p>
<p>}</p>
<p><strong>2.8 使用命名实体来替代HTML标签</strong></p>
<p><strong>问题</strong></p>
<p>你想要把示例标记粘贴到一个Web页面中，并且转义该标记，打印出尖括号而不是进行内容解析。</p>
<p><strong>解决方案</strong></p>
<p>使用正则表达式把尖括号(&lt;&gt;)转换为命名实体：&amp;lt;和&amp;gt;。</p>
<p>var pieceOfHtml = &quot;&lt;p&gt;This is a &lt;span&gt;paragraph&lt;/span&gt;&lt;/p&gt;&quot;;</p>
<p>pieceOfHtml = pieceOfHtml.replace(/&lt;/g, &quot;&amp;lt;&quot;);</p>
<p>pieceOfHtml = pieceOfHtml.replace(&gt;/g, &quot;&amp;gt;&quot;);</p>
<p>document.getElementById(&quot;searchResult&quot;).innerHTML = pieceOfHtml;</p>
<p><strong>讨论</strong></p>
<p>将标记样例粘贴到另一个Web页面中，这是很常见的。要让其中的文本打印出来，而不是让浏览器解析它，唯一的方法是把所有的尖括号转换为其等价的命名实体。</p>
<p>使用正则表达式的话，这个过程会很简单。就像在这个解决方案中所展示的那样，使用正则表达式全局标志(g)和String replace方法。</p>
<p><strong>2.9 搜索特殊字符</strong></p>
<p><strong>问题</strong></p>
<p>我们要搜索数字和字母、以及任何非数字或其他字符的内容，但是需要搜索的内容之一是特殊的正则表达式字符自身。</p>
<p><strong>解决方案</strong></p>
<p>使用反斜杠来转义模式匹配字符：</p>
<p>var re = /\\d/;</p>
<p>var pattern = &quot;\\d{4}&quot;;</p>
<p>var pattern2 = pattern.replace(re, &quot;\\D&quot;);</p>
<p><strong>讨论</strong></p>
<p>在这个解决方案中，创建了一个正则表达式，它等同于特殊字符\d，用来匹配任何数字。在需要搜索的字符串中，该模式自身是转义的。随后，用来搜索任何数字的特殊字符\D，替代了数字特殊字符。</p>
<p>听起来有点令人费解，因此，我们用一个较长的应用程序来展示。示例2-3展示了一个较小的应用程序，它首先在一个字符串中搜索4个数字的一个序列，并且用4个星号（****）替换它们。接下来，应用程序通过使用\D替代\d来修改搜索模式，然后对同样的字符串再次运行它。</p>
<p>示例2-3： 匹配正则表达式字符的正则表达式</p>
<p>&lt;DOCTYPE html&gt;</p>
<p>&lt;html xmlns=&quot;http://www.w3.org/1999/xhtml&quot;&gt;</p>
<p>&lt;head&gt;</p>
<p>&lt;title&gt;Replacement Insanity&lt;/title&gt;</p>
<p>&lt;/head&gt;</p>
<p>&lt;script&gt;</p>
<p>//&lt;![CDATA[</p>
<p>window.onload = function() {</p>
<p><a>//查找</a>&nbsp;\d</p>
<p>var re =&nbsp;<a>/\\d/;</a></p>
<p>var pattern = &quot;\\d{4}&quot;;</p>
<p>var str = &quot;I want 1111 to find 3334 certain 5343 things 8484&quot;;</p>
<p>var re2 = new RegExp(pattern, &quot;g&quot;);</p>
<p>var str1 = str.replace(re2, &quot;****&quot;);</p>
<p>alert(str1);</p>
<p>var pattern2 = pattern.replace(re, &quot;\\D&quot;);</p>
<p>var re3 = new RegExp(pattern2, &quot;g&quot;);</p>
<p>var str2 = str.replace(re3, &quot;****&quot;);</p>
<p>alert(str2);</p>
<p>};</p>
<p>//--&gt;&lt;!]]&gt;</p>
<p>&lt;/script&gt;</p>
<p>&lt;body&gt;</p>
<p>&lt;p&gt;content&lt;/p&gt;</p>
<p>&lt;/body&gt;</p>
<p>&lt;/html&gt;</p>
<p>最初的字符串如下：</p>
<p>I want 1111 to find 3334 certain 5343 things 8484</p>
<p>打印出的第一个字符串，是将最初字符串中的数字转换为星号：</p>
<p>I want **** to find **** certain **** things ****</p>
<p>打印出的第二个字符串是同样的字符串，但是字符已经转换为星号：</p>
<p>****nt 1111******** 3334******** 5343********8484</p>
<p>尽管这个例子很简单，它展示了当你想要在正则表达式字符本身上搜索的时候所遇到的一些挑战。</p>
<p><P><A href="http://www.bubuko.com/infodetail-176327.html" rel="external nofollow noreferrer">JavaScript使用正则表达式,布布扣,bubuko.com</A></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 15:44:00 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e6%ad%a3%e5%88%99%e8%a1%a8%e8%be%be%e5%bc%8f/" title="正则表达式">正则表达式</a>, <a href="https://www.biecuoliao.com/tag/pre/" title="pre">pre</a>, <a href="https://www.biecuoliao.com/tag/javascript/" title="javascript">javascript</a>, <a href="https://www.biecuoliao.com/tag/%e8%84%9a%e6%9c%ac/" title="脚本">脚本</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>JavaScript使用正则表达式的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/n0lx5Z0.html" rel="bookmark">Javascript 与正则表达式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Javascript 与正则表达式 正则表达式的定义 正则表达式与字符串对象相关的方法 相关示例 一.正则表达式(regular expression简称res) 1.定义: 一个正则表达式就是由普通字符以及特殊字符(称为元字符)组成的文字模式.该模式描述在查找文字主体时待匹配的一个或多个字符串.正则表达式作为一个模板,将某个字符模式与所搜索的字符串进行匹配. 2.作用: 正则表达式提供了功能强大.灵活而又高效的方法来处理文本.正则表达式的全面模式匹配表示法可以快速地分析大量的文本以找到特定的字			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPNORP3.html" rel="bookmark">如何使用JavaScript和正则表达式进行数据验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				利用客户端JavaScript的优势,JavaScript中的正则表达式可以简化数据验证的工作,下面与大家分享下如何使用JavaScript和正则表达式进行数据验证,感兴趣的朋友可以参考下哈 数据验证是网络应用软件从客户端接受数据的重要步骤,毕竟,您需要在使用客户数据前确保其符合预期的格式.在网络应用程序中,您可以选择使用特定平台的工具,比如ASP.NET.JSP等等,或者您可以利用客户端JavaScript的优势,JavaScript中的正则表达式可以简化数据验证的工作. 正则表达式 正则表达			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3r5RyX0.html" rel="bookmark">JavaScript中正则表达式判断匹配规则以及常用的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JavaScript中正则表达式判断匹配规则以及常用的方法: 字符串是编程时涉及到的最多的一种数据结构,对字符串进行操作的需求几乎无处不在. 正则表达式是一种用来匹配字符串的强有力的武器.它的设计思想是用一种描述性的语言来给字符串定义一个规则,凡是符合规则的字符串,我们就认为它&quot;匹配&quot;了. \d可以匹配一个数字                 '00\d'可以匹配'007' ,'\d\d\d'可以匹配'010' \w可以匹配一个字母或数字      '\w\w'可以匹配'js' \s可			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NA6WZ3.html" rel="bookmark">javascript类型系统&mdash;&mdash;正则表达式RegExp类型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				× 目录 [1]对象 [2]实例属性 [3]静态属性[4]实例方法 前面的话 前面已经介绍过javascript中正则表达式的基础语法.javascript的RegExp类表示正则表达式,String和RegExp都定义了方法,使用正则表达式可以进行强大的模式匹配和文本检索与替换.本文将介绍正则表达式的RegExp对象,以及正则表达式涉及到的属性和方法 对象 javascript中的正则表达式用RegExp对象表示,有两种写法:一种是字面量写法:另一种是构造函数写法 Perl写法 正则表达式字面			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35lmyK0.html" rel="bookmark">Javascript学习-------正则表达式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Javascript RegExp对象(正则表达式对象): RegExp:是一种模式. 当你要检索某个文本时,可以使用这种模式来描述要检索的内容. 创建RegExp对象: 使用RegExp的显式构造函数创建:             new RegExp(&quot;pattern&quot;[,flags])        使用RegExp的隐式构造函数创建:             /pattern/[flags] 解释:pattern是要使用的正则表达式模式文本 flags设置正则表达式的标志信息			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YX6JrM.html" rel="bookmark">JavaScript常用正则表达式与应用（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JavaScript的String类和RegExp对象类都定义了相关方法使用正则表达式进行模式匹配,本文将以连载方式介绍JavaScript常用正则表达式与相关应用,欢迎交流 本节是连载一,首先介绍JavaScript语言常用的正则表达式,如何应用将在后几篇介绍. 所有案例将采用在线正则表达式验证工具RegExr进行测试,地址是:http://regexr.com/v1/,本节测试截图均来自该网站. 1.匹配字符串字面值: 正则表达式字面值包含在一对正斜杠内,如:var parttern=/P/			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGamPA3.html" rel="bookmark">javascript中正则表达式的基础语法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				× 目录 [1]定义[2]特点[3]元字符[4]转义字符[5]字符组[6]量词[7]括号[8]选择[9]断言[10]模式[11]优先级[12]局限性 前面的话 正则表达式在人们的印象中可能是一堆无法理解的字符,但就是这些符号却实现了字符串的高效操作.通常的情况是,问题本身并不复杂,但没有正则表达式就成了大问题.javascript中的正则表达式作为相当重要的知识,本文将介绍正则表达式的基础语法 定义 正则表达式(Regular Expression)是一门简单语言的语法规范,是强大.便捷.高效的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vzNpR3.html" rel="bookmark">javascript之正则表达式基础知识小结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				javascript之正则表达式基础知识小结,对于学习正则表达式的朋友是个不错的基础入门资料. 元字符 ^ $ . * + ? = ! : | \ / ( ) [ ] { } 在使用这些符号时需要用“\”来进行转移. 如果记不清楚那些标点符号需要转移,可以在使用标点符号时都使用反斜杠“\” 简单匹配 1.直接量 /javascript/ 匹配带有“javascript”的字符串 比如“javascript is an object-oriented scripting language” 2.[			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AEPPZ4.html" rel="bookmark">数往知来 JavaScript js正则表达式&amp;lt&semi;二十五&amp;gt&semi;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.匹配Email地址的正则表达式:w+([-+.]w+)*@w+([-.]w+)*.w+([-.]w+)* 评注:表单验证时很实用 2.匹配网址URL的正则表达式:[a-zA-z]+://[^s]* 评注:网上流传的版本功能很有限,上面这个基本可以满足需求 3.匹配帐号是否合法(字母开头,允许5-16字节,允许字母数字下划线):^[a-zA-Z][a-zA-Z0-9_]{4,15}$ 评注:表单验证时很实用 4.匹配国内电话号码:d{3}-d{8}|d{4}-d{7} 评注:匹配形式如 051			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9MEKDy3.html" rel="bookmark" class="title">LINUX btmp 日志（lastb 命令）</a>
					<div>
						Linux下/var/log/btmp文件: 今天查看了一下服务器,发现/var/log/btmp日志文件比较大,搜索一下,此文件是记录错误登录的日志,就是说有很多人试图使用密码字典登录ssh服务,此 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49bo1DM.html" rel="bookmark" class="title">第七章-面向对象高级编程</a>
					<div>
						1 使用__slots__ 1.1 绑定属性和方法 给实例绑定属性 class Student(object): pass &gt;&gt;&gt; s = Student() &gt;&gt;&gt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j5rPAM.html" rel="bookmark" class="title">在centOS 7安装mysql 5&period;7。</a>
					<div>
						参考官方文档:https://dev.mysql.com/doc/mysql-yum-repo-quick-guide/en/ 首先创建一个repo文件 vim /etc/yum.repos.d/my ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLjGPB3.html" rel="bookmark" class="title">gulp之压缩css，less转css，浏览器实时刷新【原创】</a>
					<div>
						gulp入门 gulp浏览器实时同步 首先要下载对应的插件包: gulp-less包:cnpm install gulp-less --save-dev gulp-connect包:cnpm inst ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGPP560.html" rel="bookmark" class="title">错误代码： 0x800700b7    配置错误：定义了重复的&OpenCurlyDoubleQuote;system&period;web&period;extensions&sol;scripting&sol;scriptResourceHandler&rdquo;节</a>
					<div>
						操作环境:Windows 8.1  IIS8.5 VS2008 解决方法: 把应用程序池的.Net CLR 版本从4.0修改为2.0即可.如下图所示:					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzA8eO4.html" rel="bookmark" class="title">幼戮芯可腥e6379wf874</a>
					<div>
						新华社北京4月24日电 国际新闻早报: --朝鲜再次成功发射潜射导弹 据朝中社24日报道,朝鲜日前再次成功发射潜射导弹.朝鲜最高领导人金正恩指导了导弹发射试验.但报道没有提及发射时间和地点 韩联社23 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wjnmj0.html" rel="bookmark" class="title">wine习得知识小记</a>
					<div>
						1. VS2008: sizeof cout:56 sizeof cin:60 sizeof streamsize: 4 VS2012 sizeof cout:80 sizeof cin:96 siz ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aRr2E3.html" rel="bookmark" class="title">C&num;将一个枚举里面所有描述和value绑定到下拉列表的方法</a>
					<div>
						/// &lt;summary&gt; /// 获取枚举值的描述,如果没有描述,则返回枚举名称 /// &lt;/summary&gt; /// &lt;param name=&quot;en&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBW95A0.html" rel="bookmark" class="title">JS中图片的放大缩小没反应</a>
					<div>
						这段代码无反应: 代码如下: 1 &lt;script type=&quot;text/javascript&quot;&gt; 2 onload = function () { 3 document ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OyjdGM.html" rel="bookmark" class="title">HDU-1015-Safecracker&lpar;Java &amp;amp&semi;&amp;amp&semi; 暴力大法好 &amp;amp&semi;&amp;amp&semi; 简单字典序&rpar;</a>
					<div>
						Safecracker Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Tota ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RklK73.html" rel="bookmark" class="title">项目archive打包编译爆红</a>
					<div>
						1.项目编译通过后Connect+B 2.archive    报错解决 1&gt;.segmenttat 2&gt;.signal					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41ekZO4.html" rel="bookmark" class="title">IIS6&plus;ASP&plus;PHP5&plus;MySQL5</a>
					<div>
						本次配置PHP的服务器环境:Windows2003+IIS6+ASP+PHP5+MySQL5整个配置过程需要是使用拥有管理员权限的系统帐号登录Windows在整个配置过程中所示的截图可能根据各使用的系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38rmoKM.html" rel="bookmark" class="title">谁的青春不迷茫。。</a>
					<div>
						1.你知道自己一直让他们担心,你在没有能力时,只能证明自己不怕苦.而他们也终于第一次相信你真的不那么怕苦.你学会了说“我很好”.“我很好”不是指你终于熬到有了钱,有了朋友,有了人照顾的日子.而是你终于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KPnBY3.html" rel="bookmark" class="title">hdu 4920 Matrix multiplication&lpar;矩阵坑题&rpar;</a>
					<div>
						http://acm.hdu.edu.cn/showproblem.php?pid=4920 被这道题虐了一下午,啥也不说了.继续矩阵吧. 超时就超在每步取余上,要放在最后取余,再者注意三个循环的次序 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0a6Emk3.html" rel="bookmark" class="title">介绍PS大局观很不错的转文</a>
					<div>
						http://blog.chinaunix.net/uid-20535506-id-1931615.html PowerShell初探 PowerShell的一些特点: ü         内含上百种 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLQA9Q0.html" rel="bookmark" class="title">UIColor深入研究（CGColor，CIColor）</a>
					<div>
						由于跟人比较喜欢研究关于图层与动画方面的技术,正打算看看别人写的好东西,就遇到了好几个问题, 第一:UIClor类方法的使用 就是关于UIColor的使用,记得之前开发中我们使用的都是UIColor后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47oxgD4.html" rel="bookmark" class="title">熊猫猪新系统测试之四&colon;Ubuntu 14&period;04</a>
					<div>
						目前猫猪在单位一般用的就是乌班图系统,一方面原因是老本本性能原因跑不起来Windows,更重要的是本猫觉得Linux系统更好一些,现在用的也比较熟了,完全可以脱离Windows鸟!这4篇新系统测试文章 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoX26n0.html" rel="bookmark" class="title">Python基础篇&lpar;五&rpar;</a>
					<div>
						bool用于判断布尔值的结果是True还是False &gt;&gt;&gt; bool(&quot;a&quot;) True &gt;&gt;&gt; bool(3) True &gt;&gt;& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jw5XW3.html" rel="bookmark" class="title">修改RectTransform的值</a>
					<div>
						用uGUI的时候.经常需要动态改变RectTransform的值, 当选择不同的布局.你会发现这里的值是不同的 有的left,botom.或者posx posy 这时想改变就要通过对应的属性值了 U3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YpPdrM.html" rel="bookmark" class="title">&lbrack;R语言绘图&rsqb;plot函数的使用</a>
					<div>
						R语言中最简单的一个绘图函数就是plot了.如果之前用过matlab,用R画图的时候就很可能会尝试plot这个命令能不能使用.plot(a)一般就能得到我们想要的图.但是,如果想进一步设置其他属性,如 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
